%% Matlab seminar 2016
% Example 1: Discrete Time domain 
% ********************************************************************
% Javier Gomez Bolanos 2016 - Dept. Signal Processing and Acoustics
%                   Aalto University
% ********************************************************************
% This is an example of Matlab script that generates a sinusoidal and
% process it to obtain different parameters from the signal.
% Each process is divided in Sections which are explained separately
% Section 1: Generate data
% Section 2: Calculate RMS value of the signal
clear all; clc; % clean everything :)

% ***********************************************************************
%% Section 1: Generating signals
% generating a sine signal with frequency f0 and duration s_length sampled
% at fs frequency rate (generate it as column vector):
fs = 48e3; % sampling rate (Hz)
f0 = 1e3; % frequency of the signal (Hz)
s_length = 10; % duration in seconds

% hard way
inc_time = 1/fs; % time intervals between samples
N = ceil(s_length.*fs); % length of the vector in samples
time_axis = (0:N-1).'.*inc_time; % time axis vector
s0 = sin(2*pi.*time_axis.*f0); % generate data vector
% using Matlab functions
s1 = sine(f0,s_length,fs).';

% ***********************************************************************
%% Section 2: Root Mean Square value of the signal
% hard way
s0_rms = sqrt(sum(abs(s0).^2,1)./N); %this is the root mean square equation
% using Matlab functions
s1_rms = rms(s1,1); % this is the Matlab function for the RMS of x(n)

% Confirm that the RMS value of periodic signals is independent of duration
s0_rms1 = sqrt(sum(abs(s0(1000:1000+fs-1)).^2,1)./fs);
s1_rms1 = rms(s1(1000:1000+fs-1),1);

disp(['Signal0 RMS: ' num2str(s0_rms)]); 
disp(['Signal1 RMS: ' num2str(s1_rms)]); 
disp(['Short Signal0 RMS: ' num2str(s0_rms1)]); 
disp(['Short Signal1 RMS: ' num2str(s1_rms1)]);

