function [white, pink] = noise_generator(L,fs)
%% Matlab seminar 2016
% Example 6: Noise generator
% ********************************************************************
% Javier Gomez Bolanos 2016 - Dept. Signal Processing and Acoustics
%                   Aalto University
% ********************************************************************
% This is a Matlab function that implements a white and pink noise vectors 
% Duration L in seconds and sampled rate fs in Hz
% ********************************************************************
%% Generate white noise vector
vector_length = L*fs; % desired length of our vector
white = randn(vector_length,1);% Gaussian white noise 
% ******** Q1: Why randn() and not rand()?

% ********************************************************************
%% Generate pink noise
Nfft = vector_length; % Define FFT length
freq_axis = (0:Nfft-1)./Nfft.*fs; %Generate frequency axis
f = freq_axis(1:end/2+1); % Use only the positive frequency range
% ******** Q2: Why only positive frequencies?

White = fft(white,Nfft); % Go to frequency domain
% ******** Q3: Why we need the white noise here?

% Create a pink spectra envelope (-10dB per decade)
H = [0 sqrt(f(2) ./ f(2:end))];
H = [H.'; H(end-1:-1:2)']; % create negative spectra
H = H./rms(abs(H)); % normalize to unit power P=1
Pink = White.*H; % Multiply spectrums
pink = ifft(Pink,[],1,'symmetric'); % go to time domain
% ******** Q4: What is called the process described in the last two lines?
